' ======================================
' Rockey IV QuickBase 4.5 for DOS Sample
' ======================================

' Declare all function variables

CONST RyFind = 1
CONST RyFindNext = 2
CONST RyOpen = 3
CONST RyClose = 4
CONST RyRead = 5
CONST RyWrite = 6
CONST RyRandom = 7
CONST RySeed = 8
CONST RyWriteUserID = 9
CONST RyReadUserID = 10
CONST RySetMoudle = 11
CONST RyCheckMoudle = 12
CONST RyWriteArithmetic = 13
CONST RyCal1 = 14
CONST RyCal2 = 15
CONST RyCal3 = 16
CONST RyDecrease = 17

' Declare all error code

CONST ErrSuccess = 0
CONST ErrNoParallelPort = 1
CONST ErrNoDriver = 2
CONST ErrNoRockey = 3
CONST ErrInvalidPassword = 4
CONST ErrInvalidPasswordOrID = 5
CONST ErrSetID = 6
CONST ErrInvalidAddrOrSize = 7
CONST ErrUnknownCommand = 8
CONST ErrNotBeLevel3 = 9
CONST ErrRead = 10
CONST ErrWrite = 11
CONST ErrRandom = 12
CONST ErrSeed = 13
CONST ErrCalculate = 14
CONST ErrNoOpen = 15
CONST ErrOpenOverflow = 16
CONST ErrNoMore = 17
CONST ErrNeedFind = 18
CONST ErrDecrease = 19
CONST ErrArBadCommand = 20
CONST ErrArUnknownOpcode = 21
CONST ErrArWrongBegin = 22
CONST ErrArWrongEnd = 23
CONST ErrArValueOverflow = 24
CONST ErrUnknown = 65535
CONST ErrReceiveNull = 256
CONST ErrPrnportBusy = 257

REM ===================================================================
REM You had better not to modify the following parameter's description.
REM If you wish modify some, please care so:
REM Each parameter should keep in an independent line.
REM Before read dongle, the length of buffer must be init into a longer
REM content than those will be read.
REM ...................................................................
DIM handle(0 TO 15) AS INTEGER
DIM fcode AS INTEGER
DIM lp1 AS LONG
DIM lp2 AS LONG
DIM p1 AS INTEGER
DIM p2 AS INTEGER
DIM p3 AS INTEGER
DIM p4 AS INTEGER
REM ===================================================================

DIM i, j AS INTEGER
DIM v AS LONG
DIM rc(0 TO 3) AS INTEGER

p1 = &HC44C
p2 = &HC8F8
p3 = &H799
p4 = &HC43B
buffer$ = " "

' ==== Find Rockey ====
fcode = RyFind
CALL Rockey(fcode, handle(0), lp1, lp2, p1, p2, p3, p4, buffer$)
IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
PRINT "Find Rockey:"; HEX$(lp1)

' ==== Open Rockey ====
fcode = RyOpen
CALL Rockey(fcode, handle(0), lp1, lp2, p1, p2, p3, p4, buffer$)
IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000

i = 1
DO WHILE fcode = 0
    ' ==== Find Next ====
    fcode = RyFindNext
    CALL Rockey(fcode, handle(i), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF fcode = ErrNoMore THEN EXIT DO
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000

    ' ==== Open Rockey ====
    fcode = RyOpen
    CALL Rockey(fcode, handle(i), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000

    PRINT "Find Rockey: "; HEX$(lp1)
    i = i + 1
LOOP

    PRINT
    
FOR j = 0 TO i - 1

    ' ==== Write Rockey ====
    fcode = RyWrite
    p1 = 3
    p2 = 5
    buffer$ = "Hello"
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Write: Hello"

    ' ==== Read Rockey ====
    fcode = RyRead
    p1 = 3
    p2 = 5
    buffer$ = "                          "
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Read: "; buffer$

    ' ==== Rockey Random ====
    fcode = RyRandom
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Random: "; HEX$(p1)

    ' ==== Rockey Seed ====
    fcode = RySeed
    lp2 = &H12345678
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Seed: "; HEX$(p1); " "; HEX$(p2); " "; HEX$(p3); " "; HEX$(p4)
    rc(0) = p1
    rc(1) = p2
    rc(2) = p3
    rc(3) = p4

    ' ==== Rockey Write UserID ====
    fcode = RyWriteUserID
    lp1 = &H88888888
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Write User ID: "; HEX$(lp1)

    ' ==== Rockey Read UserID ====
    fcode = RyReadUserID
    lp1 = 0
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Read User ID: "; HEX$(lp1)

    ' ==== Rockey Set Moudle ====
    fcode = RySetMoudle
    p1 = 7
    p2 = &H2121
    p3 = 0
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Set Moudle 7: Pass = "; HEX$(p2); "  Decrease Not Allow"

    ' ==== Rockey Check Moudle ====
    fcode = RyCheckMoudle
    p1 = 7
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Check Moudle 7: ";
    IF (p2 = 1) THEN
    PRINT "Allow ";
    ELSE PRINT "No Allow ";
    END IF
    IF (p3 = 1) THEN
    PRINT "   Allow Decrease"
    ELSE PRINT "   Not Allow Decrease"
    END IF

    ' ==== Rockey Write Arthmetic 1 ====
    fcode = RyWriteArithmetic
    p1 = 0
    buffer$ = "H=H^H, A=A*23, F=B*17, A=A+F, A=A+G, A=A<C, A=A^D, B=B^B, C=C^C, D=D^D"
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Write Arithmetic 1"

    ' ==== Rockey Calculate 1 ====
    fcode = RyCal1
    lp1 = 0
    lp2 = 7
    p1 = 5
    p2 = 3
    p3 = 1
    p4 = &HFFFF
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Calculate Input: p1=5, p2=3, p3=1, p4=FFFF"
    PRINT "Result = ((5*23 + 3*17 + &2121) < 1) ^ FFFF = BC71"
    PRINT "Calculate Output: p1="; HEX$(p1); " p2="; HEX$(p2); " p3="; HEX$(p3); " p4="; HEX$(p4)

    ' ==== Rockey Write Arthmetic 2 ====
    fcode = RyWriteArithmetic
    p1 = 10
    buffer$ = "A=A+B, A=A+C, A=A+D, A=A+E, A=A+F, A=A+G, A=A+H"
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Write Arithmetic 2"

    ' ==== Rockey Calculate 2 ====
    fcode = RyCal2
    lp1 = 10
    lp2 = &H12345678
    p1 = 1
    p2 = 2
    p3 = 3
    p4 = 4
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Calculate Input: p1=1, p2=2, p3=3, p4=4"
    PRINT "Result = "; HEX$(rc(0)); "+"; HEX$(rc(1)); "+"; HEX$(rc(2)); "+"; HEX$(rc(3)); "+1+2+3+4 = 7B17"
    PRINT "Calculate Output: p1="; HEX$(p1); " p2="; HEX$(p2); " p3="; HEX$(p3); " p4="; HEX$(p4)

    ' ==== Set Module 9 Decrease ====
    fcode = RySetMoudle
    p1 = 9
    p2 = 5
    p3 = 1
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000

    ' ==== Rockey Write Arthmetic 3 ====
    fcode = RyWriteArithmetic
    p1 = 17
    buffer$ = "A=E|E, B=F|F, C=G|G, D=H|H"
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Write Arithmetic 3"

    ' ==== Rockey Calculate 3 ====
    fcode = RyCal3
    lp1 = 17
    lp2 = 6
    p1 = 1
    p2 = 2
    p3 = 3
    p4 = 4
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Show Module from 6: p1="; HEX$(p1); " p2="; HEX$(p2); " p3="; HEX$(p3); " p4="; HEX$(p4)
   
    ' ==== Decrease ====
    fcode = RyDecrease
    p1 = 9
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Decrease module 9"

    ' ==== Rockey Calculate 3 ====
    fcode = RyCal3
    lp1 = 17
    lp2 = 6
    p1 = 1
    p2 = 2
    p3 = 3
    p4 = 4
    CALL Rockey(fcode, handle(j), lp1, lp2, p1, p2, p3, p4, buffer$)
    IF (fcode <> 0) THEN PRINT "Error Code:"; fcode: GOTO 10000
    PRINT "Show Module from 6: p1="; HEX$(p1); " p2="; HEX$(p2); " p3="; HEX$(p3); " p4="; HEX$(p4)

    PRINT
    DO
    LOOP WHILE INKEY$ = ""
   
NEXT j

10000   END

